#include <stdio.h>;
#include <stdlib.h>;
#include <conio.h>;

float atomA(int i,int j) { return 1.4+2.5*i-4.7*j;  };
float atomB(int i,int j) { return -4.5+6.7*i+2.1*j; };
float atomC(int i,int j) { return 7.7-5.1*i+3.2*j;  };

void fnPrint(float*,int,int);

void fnInit(float (*f)(int,int),float *ar,int n,int m)
{ for(int i=0;i<n;i++) for(int j=0;j<m;j++) *(ar+m*i+j)=f(i,j); };

void fnMaxij(float *ar,int n,int m,int *iz,int *jz)
{
   *iz=0;*jz=0;
   for(int i=0;i<n;i++)
     for(int j=0;j<m;j++)
       if ( *(ar+i*m+j)>*(ar+(*iz)*m+(*jz)) ) { *iz=i; *jz=j; }
};


float fnMul(float *ar,int n,int m,int iz,int jz)
{
	float r=0;
	for(int i=0;i<n;i++) r+=*(ar+iz*m+i)*(*(ar+i*m+jz));
	return r;
};


void main()
{
	float 	a[5][5],b[3][3],c[4][4];
	int 	na=5,ma=5,
		nb=3,mb=3,
		nc=4,mc=4;
	fnInit(atomA,&a[0][0],na,ma);
	fnInit(atomB,&b[0][0],nb,mb);
	fnInit(atomC,&c[0][0],nc,mc);
	clrscr();
	fnPrint(&a[0][0],na,ma);
	fnPrint(&b[0][0],nb,mb);
	fnPrint(&c[0][0],nc,mc);
	int 	iz=0,jz=0;
	fnMaxij(&a[0][0],na,ma,&iz,&jz);
	printf(" a \n%8.3f %d  %d\n",a[iz][jz],iz,jz);
	printf("%8.3f \n",fnMul(&a[0][0],na,ma,iz,jz));
	fnMaxij(&b[0][0],nb,mb,&iz,&jz);
	printf("\n b \n%8.3f %d  %d\n",b[iz][jz],iz,jz);
	printf("%8.3f \n",fnMul(&b[0][0],nb,mb,iz,jz));
	fnMaxij(&c[0][0],nc,mc,&iz,&jz);
	printf("\n c \n%8.3f %d  %d\n",c[iz][jz],iz,jz);
	printf("%8.3f \n",fnMul(&c[0][0],nc,mc,iz,jz));
	getch();
}

void fnPrint(float *ar,int n,int m)
{
  printf("\n");
  for(int i=0;i<n;i++)
  {
    for(int j=0;j<m;j++) printf("%8.3f  ",*(ar+i*m+j));
    printf("\n");
  }
};